Index: LMDZ6/branches/LMDZ_ECRad/libf/phylmd/dyn1d/scm.F90
===================================================================
--- LMDZ6/branches/LMDZ_ECRad/libf/phylmd/dyn1d/scm.F90	(revision 4444)
+++ LMDZ6/branches/LMDZ_ECRad/libf/phylmd/dyn1d/scm.F90	(revision 4482)
@@ -327,5 +327,5 @@
 !      calend = 'earth_365d'
       if (calend == 'earth_360d') then
-        call ioconf_calendar('360d')
+        call ioconf_calendar('360_day')
         write(*,*)'CALENDRIER CHOISI: Terrestre a 360 jours/an'
       else if (calend == 'earth_365d') then
@@ -393,5 +393,5 @@
       call init_dimphy1D(1,llm)
       call suphel
-      call infotrac_init 
+      call init_infotrac
 
       if (nqtot>nqmx) STOP 'Augmenter nqmx dans lmdz1d.F'
@@ -496,11 +496,4 @@
         stop 'in initialization'
       endif ! forcing_GCM2SCM
-
-      print*,'mxcalc=',mxcalc
-!     print*,'zlay=',zlay(mxcalc)
-!      print*,'play=',play(mxcalc)
-
-!! When surface temperature is forced
-      tg= tsurf ! surface T used in read_tsurf1d
 
 
Index: LMDZ6/branches/LMDZ_ECRad/libf/phylmd/ener_conserv.F90
===================================================================
--- LMDZ6/branches/LMDZ_ECRad/libf/phylmd/ener_conserv.F90	(revision 4444)
+++ LMDZ6/branches/LMDZ_ECRad/libf/phylmd/ener_conserv.F90	(revision 4482)
@@ -1,4 +1,4 @@
 subroutine ener_conserv(klon,klev,pdtphys, &
- &                      puo,pvo,pto,pqo,pql0,pqs0, &
+ &                      puo,pvo,pto,qx,ivap,iliq,isol, &
  &                      pun,pvn,ptn,pqn,pqln,pqsn,dtke,masse,exner,d_t_ec)
 
@@ -28,4 +28,5 @@
 USE phys_output_var_mod, ONLY : bils_ec,bils_ech,bils_tke,bils_kinetic,bils_enthalp,bils_latent,bils_diss
 USE add_phys_tend_mod, ONLY : fl_cor_ebil 
+USE infotrac_phy, ONLY: nqtot
 
 
@@ -39,5 +40,7 @@
 INTEGER, INTENT(IN) :: klon,klev
 REAL, INTENT(IN) :: pdtphys
-REAL, DIMENSION(klon,klev), INTENT(IN)      :: puo,pvo,pto,pqo,pql0,pqs0
+REAL, DIMENSION(klon,klev), INTENT(IN)      :: puo,pvo,pto
+REAL, DIMENSION(klon,klev,nqtot), INTENT(IN):: qx
+INTEGER, INTENT(IN)                         :: ivap, iliq, isol
 REAL, DIMENSION(klon,klev), INTENT(IN)      :: pun,pvn,ptn,pqn,pqln,pqsn
 REAL, DIMENSION(klon,klev), INTENT(IN)      :: masse,exner
@@ -50,5 +53,5 @@
 REAL, DIMENSION(klon,klev+1) :: fluxu,fluxv,fluxt
 REAL, DIMENSION(klon,klev+1) :: dddu,dddv,dddt
-REAL, DIMENSION(klon,klev) :: d_u,d_v,d_t,zv,zu,d_t_ech
+REAL, DIMENSION(klon,klev) :: d_u,d_v,d_t,zv,zu,d_t_ech, pqo, pql0, pqs0
 REAL ZRCPD
 
@@ -59,4 +62,10 @@
 modname='ener_conser'
 d_t_ec(:,:)=0.
+
+IF(ivap == 0) CALL abort_physic (modname,'can''t run without water vapour',1)
+IF(iliq == 0) CALL abort_physic (modname,'can''t run without liquid water',1)
+pqo  = qx(:,:,ivap)
+pql0 = qx(:,:,iliq)
+IF(isol /= 0) pqs0 = qx(:,:,isol)
 
 IF (iflag_ener_conserv==-1) THEN
Index: LMDZ6/branches/LMDZ_ECRad/libf/phylmd/fisrtilp.F90
===================================================================
--- LMDZ6/branches/LMDZ_ECRad/libf/phylmd/fisrtilp.F90	(revision 4444)
+++ LMDZ6/branches/LMDZ_ECRad/libf/phylmd/fisrtilp.F90	(revision 4482)
@@ -89,7 +89,7 @@
   ! Coeffients de fraction lessivee : pour OFF-LINE
   !
-  REAL, DIMENSION(klon,klev),      INTENT(OUT)  :: pfrac_nucl
-  REAL, DIMENSION(klon,klev),      INTENT(OUT)  :: pfrac_1nucl
-  REAL, DIMENSION(klon,klev),      INTENT(OUT)  :: pfrac_impa
+  REAL, DIMENSION(klon,klev),      INTENT(INOUT)  :: pfrac_nucl
+  REAL, DIMENSION(klon,klev),      INTENT(INOUT)  :: pfrac_1nucl
+  REAL, DIMENSION(klon,klev),      INTENT(INOUT)  :: pfrac_impa
   !
   ! Fraction d'aerosols lessivee par impaction et par nucleation
@@ -1565,5 +1565,7 @@
         DO i=1, klon
             IF (zrflclr(i) + ziflclr(i) .GT. 0 ) THEN
-                znebprecipclr(i) = min(znebprecipclr(i), max(zrflclr(i)/(znebprecipclr(i)*rain_int_min), ziflclr(i)/(znebprecipclr(i)*rain_int_min)))
+               znebprecipclr(i) = min(znebprecipclr(i), max(zrflclr(i) &
+                    /(znebprecipclr(i)*rain_int_min), &
+                    ziflclr(i)/(znebprecipclr(i)*rain_int_min)))
             ELSE
                 znebprecipclr(i)=0.
@@ -1571,5 +1573,7 @@
 
             IF (zrflcld(i) + ziflcld(i) .GT. 0 ) THEN
-                znebprecipcld(i) = min(znebprecipcld(i), max(zrflcld(i)/(znebprecipcld(i)*rain_int_min), ziflcld(i)/(znebprecipcld(i)*rain_int_min)))
+               znebprecipcld(i) = min(znebprecipcld(i), &
+                    max(zrflcld(i)/(znebprecipcld(i)*rain_int_min), &
+                    ziflcld(i)/(znebprecipcld(i)*rain_int_min)))
             ELSE
                 znebprecipcld(i)=0.
Index: LMDZ6/branches/LMDZ_ECRad/libf/phylmd/ice_sursat_mod.F90
===================================================================
--- LMDZ6/branches/LMDZ_ECRad/libf/phylmd/ice_sursat_mod.F90	(revision 4444)
+++ LMDZ6/branches/LMDZ_ECRad/libf/phylmd/ice_sursat_mod.F90	(revision 4482)
@@ -3,19 +3,12 @@
 IMPLICIT NONE
 
+!--flight inventories
+!
 REAL, SAVE, ALLOCATABLE :: flight_m(:,:)    !--flown distance m s-1 per cell
 !$OMP THREADPRIVATE(flight_m)
 REAL, SAVE, ALLOCATABLE :: flight_h2o(:,:)  !--emitted kg H2O s-1 per cell
 !$OMP THREADPRIVATE(flight_h2o)
-
-!--parameters for gamma function
-!--Karcher and Lohmann (2002)
-!--gamma = 2.583 - t / 207.83
-! REAL, SAVE, PARAMETER :: gamma0=2.583, Tgamma=207.83
-!--Ren and MacKenzie (2005) reused by Kärcher
-!--gamma = 2.349 - t / 259.0
-REAL, PARAMETER :: gamma0=2.349, Tgamma=259.0
-!
-!--number of clouds in cell (needs to be parametrized at some point)
-REAL, PARAMETER :: N_cld = 100.
+!
+!--Fixed Parameters
 !
 !--safety parameters for ERF function
@@ -43,11 +36,19 @@
 !  alpha_cld ). Dans le rapport il est appelé beta. Il varie entre 0 et 5
 !  (tun_ratqs = 0 => pas de modification de ratqs).
-
+!
+!--gamma0 and Tgamma: define RHcrit limit above which heterogeneous freezing occurs as a function of T
+!--Karcher and Lohmann (2002)
+!--gamma = 2.583 - t / 207.83
+!--Ren and MacKenzie (2005) reused by Kärcher
+!--gamma = 2.349 - t / 259.0
+!
+!--N_cld: number of clouds in cell (needs to be parametrized at some point)
+!
+!--contrail cross section: typical value found in Freudenthaler et al, GRL, 22, 3501-3504, 1995
+!--in m2, 1000x200 = 200 000 m2 after 15 min
+!
 REAL, SAVE :: chi=1.1, l_turb=50.0, tun_N=1.3, tun_ratqs=3.0
-!$OMP THREADPRIVATE(chi,l_turb,tun_N,tun_ratqs)
-!
-!--contrail cross section, typical value found in Freudenthaler et al, GRL, 22, 3501-3504, 1995
-!--in m2, 1000x200 = 200 000 m2 after 15 min
-REAL, PARAMETER :: contrail_cross_section=200000.0  
+REAL, SAVE :: gamma0=2.349, Tgamma=259.0, N_cld=100, contrail_cross_section=200000.0
+!$OMP THREADPRIVATE(chi,l_turb,tun_N,tun_ratqs,gamma0,Tgamma,N_cld,contrail_cross_section)
 
 CONTAINS
@@ -66,9 +67,18 @@
   CALL getin_p('flag_tun_N',tun_N)
   CALL getin_p('flag_tun_ratqs',tun_ratqs)
-
+  CALL getin_p('gamma0',gamma0)
+  CALL getin_p('Tgamma',Tgamma)
+  CALL getin_p('N_cld',N_cld)
+  CALL getin_p('contrail_cross_section',contrail_cross_section)
+
+  WRITE(lunout,*) 'Parameters for ice_sursat param'
   WRITE(lunout,*) 'flag_chi = ', chi
   WRITE(lunout,*) 'flag_l_turb = ', l_turb
   WRITE(lunout,*) 'flag_tun_N = ', tun_N
   WRITE(lunout,*) 'flag_tun_ratqs = ', tun_ratqs
+  WRITE(lunout,*) 'gamma0 = ', gamma0
+  WRITE(lunout,*) 'Tgamma = ', Tgamma
+  WRITE(lunout,*) 'N_cld = ', N_cld
+  WRITE(lunout,*) 'contrail_cross_section = ', contrail_cross_section
 
 END SUBROUTINE ice_sursat_init
@@ -384,7 +394,7 @@
      !
      !--Estimating gamma 
-     gamma_ss = gamma0 - t_actuel/Tgamma
-     !gamma_prec = gamma0 - t_ancien(i,k)/Tgamma      !--formulation initiale d Audran
-     gamma_prec = gamma0 - t/Tgamma                   !--autre formulation possible basée sur le T du pas de temps
+     gamma_ss = MAX(1.0, gamma0 - t_actuel/Tgamma)
+     !gamma_prec = MAX(1.0, gamma0 - t_ancien(i,k)/Tgamma)      !--formulation initiale d Audran
+     gamma_prec = MAX(1.0, gamma0 - t/Tgamma)                   !--autre formulation possible basée sur le T du pas de temps
      !
      ! Initialisation de qvc : q_sat du pas de temps precedent
@@ -421,5 +431,7 @@
         ! On approxime en serie entiere erf-1(x)
         qvc = 2.*rneb-1.
-        qvc = qvc + PI/12.*qvc**3 + 7.*PI**2/480.*qvc**5 + 127.*PI**3/40320.*qvc**7 + 4369.*PI**4/5806080.*qvc**9 + 34807.*PI**5/182476800.*qvc**11
+        qvc = qvc + PI/12.*qvc**3 + 7.*PI**2/480.*qvc**5 &
+             + 127.*PI**3/40320.*qvc**7 + 4369.*PI**4/5806080.*qvc**9 &
+             + 34807.*PI**5/182476800.*qvc**11
         qvc = sqrt(PI)/2.*qvc
         qvc = (qvc-pdf_b)*pdf_k*sqrt(2.)
